#include <tcpTest.h>

#include <stdint.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include <socket.h>

#include <logger.h>
#include <PontCoopScheduler.h>
#include <wizHelper.h>


const uint8_t TCPTEST_SOCK;


void tcpTestHandler(void *handle) {
    static bool socketInitialized = false;

    if (isNetworkAvailable()) {
        if (! socketInitialized) {
            coloredMsg(LOG_YELLOW, "tth, initializing socket");

            int8_t res = socket(TCPTEST_SOCK, Sn_MR_TCP, 12345, SF_IO_NONBLOCK);
            coloredMsg(LOG_YELLOW, "tth, socket returns %d", res);

            if (res == TCPTEST_SOCK) {
                coloredMsg(LOG_YELLOW, "tth, socket is initialized");
                socketInitialized = true;
            }
        } else {
            coloredMsg(LOG_YELLOW, "tth, doing something useful with the socket");
        }
    } else {
        coloredMsg(LOG_YELLOW, "tth, network not yet ready");
    }
}

void tcpTestInit() {
    schAdd(tcpTestHandler, NULL, 0, 100);
}